;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: Timer16_1INT.asm
;;   Version: 2.5, Updated on 2006/06/19 at 11:17:22
;;  Generated by PSoC Designer ver 4.3  b1884 : 23 June, 2006
;;
;;  DESCRIPTION: Timer16 Interrupt Service Routine
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"
include "memory.inc"
include "Timer16_1.inc"


;-----------------------------------------------
;  Global Symbols
;-----------------------------------------------
export  _Timer16_1_ISR


AREA InterruptRAM (RAM,REL,CON)

;@PSoC_UserCode_INIT@ (Do not change this line.)
;---------------------------------------------------
; Insert your custom declarations below this banner
;---------------------------------------------------

;------------------------
; Includes
;------------------------

	
;------------------------
;  Constant Definitions
;------------------------


;------------------------
; Variable Allocation
;------------------------


;---------------------------------------------------
; Insert your custom declarations above this banner
;---------------------------------------------------
;@PSoC_UserCode_END@ (Do not change this line.)


AREA UserModules (ROM, REL)

;-----------------------------------------------------------------------------
;  FUNCTION NAME: _Timer16_1_ISR
;
;  DESCRIPTION: Unless modified, this implements only a null handler stub.
;
;-----------------------------------------------------------------------------
;

_Timer16_1_ISR:

   ;@PSoC_UserCode_BODY@ (Do not change this line.)

;Timer16_1 interrupt routine (24 MHz/65536=366.2 Hz --     SysClk)
;Returns: [CaptCnt], [Accum] and [ready] (bits3,2=1 when result is ready)


include "math.inc"
include "TX8_1.inc"
	;----- 366.2 Hz -----
    push A
    push X

;----------------------------   () -----------------------------------
jmp .nopulsing
;   366.2 Hz
;   ,  : 29,30,31,31,30,29 ... 2,1,0,0,1,2 ...
; =366.2/(32*2)=5,7Hz (  C  0  31)
include "SCBLOCK_2.inc"
include "lpf_1.inc"

	mov A,[phase+1]
	add A,[phase]	;+1  -1
	cmp A,32
	jnz .n1
		mov A,31		
		mov [phase],0xFF ;-1 
		jmp .n2
	.n1:
	cmp A,17;0xFF
	jnz .n2
		mov A,17	
		mov [phase],1
.n2:;   SCBLOCK_2_cr0
	;mov A, 31

	mov [phase+1],A
	mov A,reg[SCBLOCK_2_cr0]
	and A,0xE0 ; () 
	or A,[phase+1]
	mov reg[SCBLOCK_2_cr0],A

.nopulsing:
;----------------------------   ( ) -----------------------------------
;   366.2 Hz
	call modulation

;-------------------------------- "TX" process (UART)---------------------------------
	mov A,[StringPt]
	jz .nosend
		mvi A,[StringPt]
		jnz .no_eol
			mov A,9						;if zero, send "tab" ; "EOL" code
			mov [StringPt],0			;zero pointer to stop process
		.no_eol:
		mov REG[TX8_1_TX_BUFFER_REG],A	;send char via UART
	.nosend:


;---------------------- next scan code for "getkey" procedure -------------------------
    asr [am]            ;next mask (mask >> 1)
	jnz .no_restore
    	mov [am],0b00010000 ;restore start mask
    .no_restore:	

;------------------- dinamic indication of LEDs (Port2) ---------------------------------
;     [an+0]...[an+10] (  2 ).
;	1-     PRT2DM1,
;	2-     PRT2DM0 (   -  PRT2DM1),     
;			  :
;			0  0 -  ""
;			0  1 -   ."0"
;			1  1 -   ."1"
; 5      (366.2/5=73.2)),  :
;     an+0:       an+2:       an+4:       an+6:      an+8:      an+10:
; /-> 1 --> - -->  -->  --> mute |--> 2 --\       (2    )
; |          |                                             |            |
; \----------|---------------------------------------------/            |
;            \----------------------------------------------------------/
;    "1"  "2"        (366.2/5/2=36.6),      
;     , [an+0].[an+1]  [an+12].[an+13]    
;
	;-------------           -
	cmp [ai],an+4			; ?
	jnz .noOctaveSlot		;
		; 
		;    - -       -
		tst reg[PRT1DR],0b01000000	;  P1[6],    
		jz .noKeypressed			;   
			; 
			mov A,[an+2]			; -
			or [keyscan],A			;  [keyscan] ( 4   366.2/5/4=18.3)
		.noKeypressed:
		asr [an+2]					; -	
		asr [an+3]	
		jnz .noStartcode
			mov [an+2],0b00001000	; ,   -
			mov [an+3],0b00001000
			or [keyscan],0b10000000	;     getkey (18.3)
		.noStartcode:
		;   
		tst [aflag],0b00000001	; ?
		jz .nozero				;
			tst [aflag],0b00011000	;      (2-36.6, 3-18, 4-9, 5-4.5,)
			jz .nozero
				mov A,0				; 1-  ,    
				inc [ai]			; [ai]	
				jmp .A2PRT
		.nozero:
	.noOctaveSlot:
	;-----------------------------------
	mvi A,[ai]				;load 1-st byte of LED data to Port Data Register
.A2PRT:
	mov reg[PRT2DR],A
	mvi A,[ai]				;load 2-nd byte of LED data to Port Drive Mode Registers
	M8C_SetBank1
	mov reg[PRT2DM0],A
	cpl A
	mov reg[PRT2DM1],A
	M8C_SetBank0
	;     -     2  "aflag"
	cmp [ai],an+10			; . (   )
	jc .noload				; . < 10
 		jz .check			; . = 10
			;next address > 10
			mov [ai],an+2		;      "2" 
			;-------------     (  366.2/5/2 = 36.6 )
			call volumeADC
			;-------------
 			jmp .noload1	
		.check:
		;next address = 10
		tst [aflag],0b0000100	;    ( 2=1 -  )
		jnz .noload
			mov [ai],an+0		;  -   0- 
			.noload1:
			add [aflag],0b00000100		; 2 ( 7...2 -      )
	.noload:


;----------------------- free run system timer (366.2 Hz counter)-------------------
	inc [systimer+0]		;increment
	adc [systimer+1],0


;--------------------------------- frequency meter ---------------------------------
;(   0.1    37 )
	dec [TimerCnt+0]	;decrement "TimerCnt"
	jnc end	;skip if time is not over
		;it's time to save the result
		mov A,[ready]
		jnz .skip			;if data are still not processed
			mov	[CaptCnt+0], [c_CaptCnt+0]	;write result   c_CaptCnt -> CaptCnt
			mov	[CaptCnt+1], [c_CaptCnt+1]	;
			mov	[CaptCnt+2], [c_CaptCnt+2]	;
			math_mov5	Accum, c_Accum		;write result   c_Accum -> Accum
			mov [ready],0b00001000 ;set bit "ready"
		.skip:

		;start new measurement cycle
		mov [TimerCnt+0],[TimerCntMax+0]
	
		mov A,0
		mov [c_Accum+0],A		;c_Accum=0
		mov [c_Accum+1],A
		mov [c_Accum+2],A
		mov [c_Accum+3],A
		mov [c_Accum+4],A
		mov [c_CaptCnt+0],A		;c_CaptCnt=0
		mov [c_CaptCnt+1],A
		mov [c_CaptCnt+2],A
	end:
    pop X
    pop A
 	reti
 
;-----------------------------------------------------------------------------
;  DESCRIPTION:	  .
;				   3    
;				 .
;				   3-  (36.6/3 = 12.2 )
;  RETURNS:		[an+6][an+7] -    ""   
;				[cv] -  
;-----------------------------------------------------------------------------
include "CMPPRG_1.inc"
volumeADC:
	tst reg[CMP_CR0],0x20	;  Comparator Bus 1
	jz .noshift
	   	asl [cv]			; .   ,       
	.noshift:
	dec [ci]				; 
	jnc .nofinished			;    
		;  -           
		;[cv] = 0001, 0010, 0100, 1000)
    	mov [an+6],0b10000000		;,    PRT2DR (  )
   		mov [an+7],[cv]				;       (PRT2DM0) (: 0b10000010  1- 	)		
		and [an+7],0b00011110		;  0	
		or  [an+7],0b10000000		;  7		
		;   
		mov [ci],2			;  
		mov [cv],0b00000001	;   0-  (  Mute,    )
	.nofinished:
	;   [ci]=0,1,2       
	;(    "Mute")
	mov A,[ci]					;     
	tst [an+8],0b10000000		;  "Mute"
	jnz .mute					;  "Mute",     
		add A,4					;  ,   
	.mute:
	index thresholds			;    
	mov reg[CMPPRG_1_COMP_CR0],A;     
	ret

;     
;(  "Ah"    Gain=1, RTopMux=Vdd, RBotMux=Vss    )
.LITERAL
;                  "Mute"         
thresholds:	DB	0Ah,2Ah,4Ah,0,    2Ah,5Ah,8Ah,0 ; TapPosition = 4,2,0  8,5,2 -   
.ENDLITERAL		


;-----------------------------------------------------------------------------
;  DESCRIPTION:	  ( SCBLOCK_2)
;
;  ARGUMENTS:	[modindex]	 7...5 -  ,  4...0   0
;
;  RETURNS:		[phase] -  
;-----------------------------------------------------------------------------
modulation:
	mov A,[phase]			;  
	and A,0x1F				;  
	or A,[modindex]			;   ( 7...5)
	index table0
	mov [phase+1],A			; 
	mov A,reg[SCBLOCK_2_cr0]
	and A,0xE0 				; () 
	or A,[phase+1]
	mov reg[SCBLOCK_2_cr0],A
	inc [phase]				;   (  , ..   )
	ret
.LITERAL
table0:	;   SCBLOCK_2_cr0    ( 32 )
;0 -  
	DB 31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31
;1 -  
	DB 31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31
;2 -  
	DB 31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31,31
;3 -  +  2...15,   . -  3  
	DB 29,30,31,30,29,30,31,30,29,29,30,31,31,30,29,28,28,29,30,30,30,31,31,31,30,31,30,30,31,30,30,30
;4 -  +  2...8,   . -  5  
	DB 30,29,28,27,27,28,29,30,30,30,29,28,27,26,26,27,28,29,29,29,30,31,30,29,30,31,31,30,29,29,29,30
;5 -  +  2,3 -  6  
	DB 28,28,29,29,30,31,31,30,29,28,27,26,25,26,27,28,29,29,30,30,29,29,29,30,30,31,31,31,30,29,29,28
;6 -  +  2 -  7  
	DB 26,25,24,24,24,24,24,25,26,26,26,26,26,25,25,24,24,23,23,24,25,26,27,28,29,30,31,31,30,29,28,27
;7 -  -  12  
	DB 31,31,31,30,29,28,27,26,25,24,23,22,21,20,19,19,19,19,19,20,21,22,23,24,25,26,27,28,29,30,31,31
.ENDLITERAL		


   ;@PSoC_UserCode_END@ (Do not change this line.)

   reti


; end of file Timer16_1INT.asm
